Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPEvaluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPEvaluator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPEvaluator.cs	(revision 7412)
@@ -38,9 +38,18 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public ILookupParameter<DoubleValue> InfeasibilityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["Infeasibility"]; }
+    public ILookupParameter<DoubleValue> FlowDistanceQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["FlowDistanceQuality"]; }
     }
-    public IValueLookupParameter<DoubleValue> PenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["Penalty"]; }
+    public ILookupParameter<DoubleValue> InstallationQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InstallationQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> OverbookedCapacityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["OverbookedCapacity"]; }
+    }
+    public IValueLookupParameter<DoubleValue> TransportationCostsParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
+    }
+    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
     }
     public ILookupParameter<DoubleMatrix> WeightsParameter {
@@ -52,7 +61,4 @@
     public ILookupParameter<DoubleMatrix> InstallationCostsParameter {
       get { return (ILookupParameter<DoubleMatrix>)Parameters["InstallationCosts"]; }
-    }
-    public ILookupParameter<DoubleValue> TransportationCostsParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
     public ILookupParameter<DoubleArray> DemandsParameter {
@@ -71,11 +77,13 @@
     public GQAPEvaluator()
       : base() {
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality a.k.a. fitness of the solution."));
-      Parameters.Add(new LookupParameter<DoubleValue>("Infeasibility", "The infeasibility describes the sum of the overbooked capacities."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("Penalty", "The multiplier for the constraint violation when added to the quality.", new DoubleValue(1000)));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the solution."));
+      Parameters.Add(new LookupParameter<DoubleValue>("FlowDistanceQuality", "The quality regarding the flow-distance criteria."));
+      Parameters.Add(new LookupParameter<DoubleValue>("InstallationQuality", "The quality regarding the installation costs."));
+      Parameters.Add(new LookupParameter<DoubleValue>("OverbookedCapacity", "The sum of the overbooked capacities relative to the capacity of each location."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights or distance matrix already."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", "The multiplier for the constraint violation when added to the quality."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", "The weights matrix describes the flows between the equipments."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", "The distances matrix describes the distances between the locations at which the equipment can be installed."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", "The installation costs matrix describes the installation costs of installing equipment i at location j"));
-      Parameters.Add(new LookupParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already."));
       Parameters.Add(new LookupParameter<DoubleArray>("Demands", "The demands vector describes the space requirements of the equipments."));
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", "The capacities vector describes the available space at the locations."));
@@ -87,31 +95,47 @@
     }
 
-    public static DoubleValue Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
-      DoubleMatrix installCosts, double transportCosts, DoubleArray demands, DoubleArray capacities,
-      out double infeasibility) {
-      double quality = 0;
+    public static double Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
+                                  DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
+                                  DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty) {
+      double flowDistanceQuality, installationQuality, overbookedCapacity;
+      Evaluate(assignment, weights, distances, installCosts, demands, capacities,
+        out flowDistanceQuality, out installationQuality, out overbookedCapacity);
+      return GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity,
+        transportationCosts.Value, overbookedCapacityPenalty.Value);
+    }
+
+    public static void Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
+                                DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
+                                out double flowDistanceQuality, out double installationQuality, out double overbookedCapacity) {
+      flowDistanceQuality = 0;
+      installationQuality = 0;
       int len = assignment.Length;
       var slack = (DoubleArray)capacities.Clone();
       for (int i = 0; i < len; i++) {
-        quality += installCosts[i, assignment[i]];
+        installationQuality += installCosts[i, assignment[i]];
         for (int j = 0; j < len; j++) {
-          quality += transportCosts * weights[i, j] * distances[assignment[i], assignment[j]];
+          flowDistanceQuality += weights[i, j] * distances[assignment[i], assignment[j]];
         }
         slack[assignment[i]] -= demands[i];
       }
+      overbookedCapacity = slack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -x.V / capacities[x.Index]).Sum();
+    }
 
-      infeasibility = -slack.Where(x => x < 0).Sum();
-      return new DoubleValue(quality);
+    public static double GetCombinedQuality(double flowDistanceQuality, double installationQuality, double overbookedCapacity,
+      double transportationCosts, double overbookedCapacityPenalty) {
+      return installationQuality
+        + transportationCosts * flowDistanceQuality
+        + overbookedCapacityPenalty * overbookedCapacity;
     }
 
     public override IOperation Apply() {
-      IntegerVector assignment = AssignmentParameter.ActualValue;
-      DoubleMatrix weights = WeightsParameter.ActualValue;
-      DoubleMatrix distances = DistancesParameter.ActualValue;
-      DoubleMatrix installCosts = InstallationCostsParameter.ActualValue;
-      double transportCosts = TransportationCostsParameter.ActualValue.Value;
-      DoubleArray demands = DemandsParameter.ActualValue;
-      DoubleArray capacities = (DoubleArray)CapacitiesParameter.ActualValue.Clone();
-      double penalty = PenaltyParameter.ActualValue.Value;
+      var assignment = AssignmentParameter.ActualValue;
+      var weights = WeightsParameter.ActualValue;
+      var distances = DistancesParameter.ActualValue;
+      var installCosts = InstallationCostsParameter.ActualValue;
+      var demands = DemandsParameter.ActualValue;
+      var capacities = CapacitiesParameter.ActualValue;
+      var transportCosts = TransportationCostsParameter.ActualValue.Value;
+      double penalty = OverbookedCapacityPenaltyParameter.ActualValue.Value;
 
       if (weights.Rows != weights.Columns || distances.Rows != distances.Columns
@@ -120,9 +144,13 @@
         throw new InvalidOperationException("ERROR: The problem configuration is not valid! Check the sizes of the weights (NxN), distances (MxM) and installation costs (NxM) matrices as well as the length of the demand (N) and capacities (M) vectors.");
 
-      double infeasibility;
-      var quality = Evaluate(assignment, weights, distances, installCosts, transportCosts, demands, capacities, out infeasibility);
+      double flowDistanceQuality, installationQuality, overbookedCapacity;
+      Evaluate(assignment, weights, distances, installCosts, demands, capacities,
+        out flowDistanceQuality, out installationQuality, out overbookedCapacity);
 
-      InfeasibilityParameter.ActualValue = new DoubleValue(infeasibility);
-      QualityParameter.ActualValue = new DoubleValue(quality.Value + penalty * infeasibility);
+      FlowDistanceQualityParameter.ActualValue = new DoubleValue(flowDistanceQuality);
+      InstallationQualityParameter.ActualValue = new DoubleValue(installationQuality);
+      OverbookedCapacityParameter.ActualValue = new DoubleValue(overbookedCapacity);
+
+      QualityParameter.ActualValue = new DoubleValue(GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity, transportCosts, penalty));
       return base.Apply();
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPNMoveEvaluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPNMoveEvaluator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPNMoveEvaluator.cs	(revision 7412)
@@ -44,9 +44,30 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
+    public ILookupParameter<DoubleValue> FlowDistanceQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["FlowDistanceQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> InstallationQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InstallationQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> OverbookedCapacityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["OverbookedCapacity"]; }
+    }
     public ILookupParameter<DoubleValue> MoveQualityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
     }
-    public ILookupParameter<DoubleValue> MoveInfeasibilityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["MoveInfeasibility"]; }
+    public ILookupParameter<DoubleValue> MoveFlowDistanceQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveFlowDistanceQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> MoveInstallationQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveInstallationQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> MoveOverbookedCapacityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveOverbookedCapacity"]; }
+    }
+    public IValueLookupParameter<DoubleValue> TransportationCostsParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
+    }
+    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
     }
     public ILookupParameter<DoubleMatrix> WeightsParameter {
@@ -58,7 +79,4 @@
     public ILookupParameter<DoubleMatrix> InstallationCostsParameter {
       get { return (ILookupParameter<DoubleMatrix>)Parameters["InstallationCosts"]; }
-    }
-    public ILookupParameter<DoubleValue> TransportationCostsParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
     public ILookupParameter<DoubleArray> DemandsParameter {
@@ -77,10 +95,16 @@
       Parameters.Add(new LookupParameter<NMove>("Move", "The move to perform."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The solution quality."));
+      Parameters.Add(new LookupParameter<DoubleValue>("FlowDistanceQuality", "The quality regarding the flow-distance criteria."));
+      Parameters.Add(new LookupParameter<DoubleValue>("InstallationQuality", "The quality regarding the installation costs."));
+      Parameters.Add(new LookupParameter<DoubleValue>("OverbookedCapacity", "The sum of the overbooked capacities relative to the capacity of each location."));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The quality of the move if it would be applied."));
-      Parameters.Add(new LookupParameter<DoubleValue>("MoveInfeasibility", "The infeasibility of the move if it would be applied."));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveFlowDistanceQuality", "The quality of the move regarding the flow-distance criteria."));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveInstallationQuality", "The quality of the move regarding the installation costs."));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveOverbookedCapacity", "The sum of the overbooked capacities of the move relative to the capacity of each location."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", "The multiplier for the constraint violation when added to the quality."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights or distance matrix already."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", "The weights matrix describes the flows between the equipments."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", "The distances matrix describes the distances between the locations at which the equipment can be installed."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", "The installation costs matrix describes the installation costs of installing equipment i at location j"));
-      Parameters.Add(new LookupParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already."));
       Parameters.Add(new LookupParameter<DoubleArray>("Demands", "The demands vector describes the space requirements of the equipments."));
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", "The capacities vector describes the available space at the locations."));
@@ -91,13 +115,19 @@
     }
 
-    public static DoubleValue Evaluate(NMove move, IntegerVector assignment, DoubleValue quality,
-                                  DoubleArray demands, DoubleArray capacities,
-                                  DoubleMatrix weights, DoubleMatrix distances,
-                                  DoubleMatrix installationCosts,
-                                  DoubleValue transportationCosts,
-                                  out DoubleValue moveInfeasibility) {
-      double moveQuality = quality.Value;
+    public static double Evaluate(NMove move, IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
+      DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty) {
+      double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
+      Evaluate(move, assignment, weights, distances, installationCosts, demands, capacities,
+        out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
+      return GQAPEvaluator.GetCombinedQuality(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
+        transportationCosts.Value, overbookedCapacityPenalty.Value);
+    }
+
+    public static void Evaluate(NMove move, IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
+      DoubleArray demands, DoubleArray capacities, out double moveFlowDistanceQuality, out double moveInstallationQuality, out double moveOverbookedCapacity) {
+      moveFlowDistanceQuality = moveInstallationQuality = moveOverbookedCapacity = 0.0;
       int moves = move.N;
       var slack = (DoubleArray)capacities.Clone();
+      var oldSlack = (DoubleArray)slack.Clone();
       Dictionary<int, int> moving = new Dictionary<int, int>();
       for (int i = 0; i < moves; i++) moving.Add(move.Equipments[i], move.Locations[i]);
@@ -106,35 +136,56 @@
         int equip = move.Equipments[i];
         int newLoc = move.Locations[i];
-        moveQuality -= installationCosts[equip, assignment[equip]];
-        moveQuality += installationCosts[equip, newLoc];
+        moveInstallationQuality -= installationCosts[equip, assignment[equip]];
+        moveInstallationQuality += installationCosts[equip, newLoc];
         for (int j = 0; j < assignment.Length; j++) {
           if (!moving.ContainsKey(j)) {
-            moveQuality += transportationCosts.Value * weights[equip, j] * (distances[newLoc, assignment[j]] - distances[assignment[equip], assignment[j]]);
-            moveQuality += transportationCosts.Value * weights[j, equip] * (distances[assignment[j], newLoc] - distances[assignment[j], assignment[equip]]);
+            moveFlowDistanceQuality += weights[equip, j] * distances[newLoc, assignment[j]];
+            moveFlowDistanceQuality -= weights[equip, j] * distances[assignment[equip], assignment[j]];
+            moveFlowDistanceQuality += weights[j, equip] * distances[assignment[j], newLoc];
+            moveFlowDistanceQuality -= weights[j, equip] * distances[assignment[j], assignment[equip]];
             if (i == 0) { // only once for each untouched equipment deduct the demand from the capacity
               slack[assignment[j]] -= demands[j];
+              oldSlack[assignment[j]] -= demands[j];
             }
           } else {
-            moveQuality += transportationCosts.Value * weights[equip, j] * (distances[newLoc, moving[j]] - distances[assignment[equip], assignment[j]]);
-            moveQuality += transportationCosts.Value * weights[j, equip] * (distances[moving[j], newLoc] - distances[assignment[j], assignment[equip]]);
+            moveFlowDistanceQuality += weights[equip, j] * distances[newLoc, moving[j]];
+            moveFlowDistanceQuality -= weights[equip, j] * distances[assignment[equip], assignment[j]];
           }
         }
         slack[newLoc] -= demands[equip];
+        oldSlack[assignment[equip]] -= demands[equip];
       }
 
-      moveInfeasibility = new DoubleValue(-slack.Where(x => x < 0).Sum());
-      return new DoubleValue(moveQuality);
-
+      moveOverbookedCapacity = slack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -x.V / capacities[x.Index]).Sum()
+                               - oldSlack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -x.V / capacities[x.Index]).Sum();
     }
 
     public override IOperation Apply() {
-      DoubleValue moveInfeasibility;
-      MoveQualityParameter.ActualValue = Evaluate(MoveParameter.ActualValue,
-                 AssignmentParameter.ActualValue, QualityParameter.ActualValue,
-                 DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
-                 WeightsParameter.ActualValue, DistancesParameter.ActualValue,
-                 InstallationCostsParameter.ActualValue,
-                 TransportationCostsParameter.ActualValue, out moveInfeasibility);
-      MoveInfeasibilityParameter.ActualValue = moveInfeasibility;
+      double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
+      double quality = QualityParameter.ActualValue.Value;
+      double transportationCosts = TransportationCostsParameter.ActualValue.Value;
+      double overbookedCapacityPenalty = OverbookedCapacityPenaltyParameter.ActualValue.Value;
+
+      double flowDistanceQuality = FlowDistanceQualityParameter.ActualValue.Value;
+      double installationQuality = InstallationQualityParameter.ActualValue.Value;
+      double overbookedCapacity = OverbookedCapacityParameter.ActualValue.Value;
+
+      Evaluate(MoveParameter.ActualValue,
+               AssignmentParameter.ActualValue,
+               WeightsParameter.ActualValue, DistancesParameter.ActualValue,
+               InstallationCostsParameter.ActualValue,
+               DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
+               out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
+
+      MoveFlowDistanceQualityParameter.ActualValue = new DoubleValue(flowDistanceQuality + moveFlowDistanceQuality);
+      MoveInstallationQualityParameter.ActualValue = new DoubleValue(installationQuality + moveInstallationQuality);
+      MoveOverbookedCapacityParameter.ActualValue = new DoubleValue(moveOverbookedCapacity);
+
+      MoveQualityParameter.ActualValue = new DoubleValue(GQAPEvaluator.GetCombinedQuality(
+        flowDistanceQuality + moveFlowDistanceQuality,
+        installationQuality + moveInstallationQuality,
+        moveOverbookedCapacity,
+        transportationCosts,
+        overbookedCapacityPenalty));
       return base.Apply();
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPIntegerVectorProximityCalculator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPIntegerVectorProximityCalculator.cs	(revision 7412)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPIntegerVectorProximityCalculator.cs	(revision 7412)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public static class GQAPIntegerVectorProximityCalculator {
+    public static double CalculateGenotypeSimilarity(IntegerVector a, IntegerVector b) {
+      int similar = 0;
+      for (int i = 0; i < a.Length; i++) {
+        if (a[i] == b[i]) similar++;
+      }
+      return similar / (double)a.Length;
+    }
+
+    public static double CalculateGenotypeDistance(IntegerVector a, IntegerVector b) {
+      return 1.0 - CalculateGenotypeSimilarity(a, b);
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7412)
@@ -53,12 +53,15 @@
       get { return (ValueParameter<DoubleMatrix>)Parameters["InstallationCosts"]; }
     }
+    public ValueParameter<DoubleArray> DemandsParameter {
+      get { return (ValueParameter<DoubleArray>)Parameters["Demands"]; }
+    }
+    public ValueParameter<DoubleArray> CapacitiesParameter {
+      get { return (ValueParameter<DoubleArray>)Parameters["Capacities"]; }
+    }
     public FixedValueParameter<DoubleValue> TransportationCostsParameter {
       get { return (FixedValueParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public ValueParameter<DoubleArray> DemandsParameter {
-      get { return (ValueParameter<DoubleArray>)Parameters["Demands"]; }
-    }
-    public ValueParameter<DoubleArray> CapacitiesParameter {
-      get { return (ValueParameter<DoubleArray>)Parameters["Capacities"]; }
+    public FixedValueParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
+      get { return (FixedValueParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
     }
     public OptionalValueParameter<IItem> BestKnownSolutionParameter {
@@ -80,15 +83,19 @@
       set { InstallationCostsParameter.Value = value; }
     }
+    public DoubleArray Demands {
+      get { return DemandsParameter.Value; }
+      set { DemandsParameter.Value = value; }
+    }
+    public DoubleArray Capacities {
+      get { return CapacitiesParameter.Value; }
+      set { CapacitiesParameter.Value = value; }
+    }
     public double TransportationCosts {
       get { return TransportationCostsParameter.Value.Value; }
       set { TransportationCostsParameter.Value.Value = value; }
     }
-    public DoubleArray Demands {
-      get { return DemandsParameter.Value; }
-      set { DemandsParameter.Value = value; }
-    }
-    public DoubleArray Capacities {
-      get { return CapacitiesParameter.Value; }
-      set { CapacitiesParameter.Value = value; }
+    public double OverbookedCapacityPenalty {
+      get { return TransportationCostsParameter.Value.Value; }
+      set { TransportationCostsParameter.Value.Value = value; }
     }
     #endregion
@@ -114,4 +121,5 @@
       Parameters.Add(new ValueParameter<DoubleMatrix>("InstallationCosts", "The installation costs matrix describes the installation costs of installing equipment i at location j", new DoubleMatrix()));
       Parameters.Add(new FixedValueParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.", new DoubleValue(1)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("OverbookedCapacityPenalty", "The multiplier for the constraint violation when added to the quality.", new DoubleValue(1000)));
       Parameters.Add(new ValueParameter<DoubleArray>("Demands", "The demands vector describes the space requirements of the equipments.", new DoubleArray()));
       Parameters.Add(new ValueParameter<DoubleArray>("Capacities", "The capacities vector describes the available space at the locations.", new DoubleArray()));
@@ -183,5 +191,5 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserializationHook() {
+    private void AfterDeserialization() {
       AttachEventHandlers();
     }
@@ -220,24 +228,34 @@
       }
       foreach (var op in Operators.OfType<IGQAPEvaluationOperator>()) {
+        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
+        op.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
         op.WeightsParameter.ActualName = WeightsParameter.Name;
         op.DistancesParameter.ActualName = DistancesParameter.Name;
         op.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-        op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
         op.DemandsParameter.ActualName = DemandsParameter.Name;
         op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
       }
       foreach (var op in Operators.OfType<IGQAPLocalImprovementOperator>()) {
+        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
+        op.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
+        op.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
+        op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
+        op.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
         op.WeightsParameter.ActualName = WeightsParameter.Name;
         op.DistancesParameter.ActualName = DistancesParameter.Name;
         op.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
-        op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
         op.DemandsParameter.ActualName = DemandsParameter.Name;
         op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-        op.InfeasibilityParameter.ActualName = Evaluator.InfeasibilityParameter.ActualName;
       }
       foreach (var op in Operators.OfType<IGQAPManipulator>()) {
         op.IntegerVectorParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+      }
+      foreach (var op in Operators.OfType<IGQAPMerger>()) {
+        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.MaximizationParameter.ActualName = MaximizationParameter.Name;
       }
       foreach (var op in Operators.OfType<IGQAPMoveOperator>()) {
